<?php

/*
	Copyright 2004 
	John Rankin john.rankin@affinity.co.nz

        Based on guestbook and journal to allow diary and comment pages
*/

SDV($MessageEntryFmt,"<div id='message'>
<form action='\$PageUrl' method='post'>
<fieldset class='wikilog'>
<legend>Post a comment</legend>

<input type='hidden' name='pagename' value='\$PageName' />
<input type='hidden' name='action' value='jpost' />
<input type='hidden' name='order' value='\$Chrono' />

<br />

<label for='author' title='Enter your name here' class='left'>Author</label>
<input type='text' id='author' name='author' size='40' /><br />

<label for='url' title='Enter your URL or email address here' class='left'>URL/Email</label>
<input type='text' id='url' name='url' size='40' /><br />

<label for='comment' title='Enter your message here' class='left'>Message</label>
<textarea name='text' id='comment' rows='6' cols='45'></textarea><br />

<div class='right'>
  <input type='submit' name='post' value='Post' />
  <input type='submit' name='preview' value='Preview' />
  <input type='reset' value='Reset' />
</div>

<div class='markup'>
<div class='header'>Markup</div> 
<strong>Paragraphs:</strong> for a new paragraph, press the <em>return</em> key twice; use -&gt; to indent text
<br clear='all' /><strong>Lists:</strong> * for bullet lists, # for numbered lists, :term:definition for definition lists
<br clear='all' /><strong>Emphasis:</strong> ''italics'', '''bold''', '''''bold italics''''', @@typewriter@@ (monospaced)

<br clear='all' /><strong>References:</strong> use a URL (http://www.example.com)
<br clear='all' /><strong>Separators:</strong> !, !!, !!! for headings, ---- for horizontal line
<br clear='all' /><strong>Change size:</strong> [+...+] is bigger, [-...-] is smaller
<br clear='all' /><strong>Prevent formatting:</strong> [=...=]
<br clear='all' /><strong>Allowed HTML tags:</strong> b, i, u, sup, sub, a, img, p, pre, br, q
</div>

</fieldset>
</form>
</div>");
	
SDV($CalendarEntryFmt,"<div id='message'>
<form action='\$PageUrl' method='post'>
<fieldset class='wikilog'>
<legend>Post a new blog entry</legend

<input type='hidden' name='pagename' value='\$PageName' />
<input type='hidden' name='action' value='jpost' />
<input type='hidden' name='order' value='x\$Chrono' />

<br />

<label for='headline' title='Enter the headline here' class='left'>Headline</label>
<input type='text' id='headline' name='headline' size='45' /><br />

<label for='story' title='Enter your story here' class='left'>Story</label>
<textarea name='text' id='story' rows='25' cols='60'></textarea><br />

<label for='author' title='Enter your name here' class='left'>Author</label>
<input type='text' id='author' name='author' value='\$author' size='32' />
<input type='checkbox' name='comment' value='comment' checked /> Allow comments?<br />

<div class='right'>
  <input type='submit' name='post' value='Post' />
  <input type='reset' value='Reset' />
</div>

</fieldset>
</form>
</div>");

$PreviewFmt=array(
  "function:ProcessTextDirectives",
  "<h2 class='wikiaction'>Comment preview</h2>
    <b>Your comment is unsaved</b><hr /><p></p>",
  "function:PrintText",
  "<hr /><b>End of preview -- remember to post your comment</b>");

if ("$JournalDateFmt" == "") $JournalDateFmt = '%d %B %Y';

if ("$JournalTimeFmt" == "") $JournalTimeFmt = '%H:%M';

if ("$JournalPattern" == "") $JournalPattern = '/Journal$/';

if ($action == 'jpost') { 
  SDV($HandleActions['jpost'],'HandleJDMPost');
} 
else if ($action=='print' || $action=='publish') {
  $InlineReplacements['/\\[\\[\\$Comment(chrono)?\\]\\]/'] = '';
  $InlineReplacements['/\\[\\[\\$Wikilog(chrono)?\\]\\]/'] = '';
} 
else { 
  SDV($InlineReplacements['/\\[\\[\\$Comment(chrono)?\\]\\]/e'],
	   "str_replace('\$Chrono','\$1',
               FmtPageName(\$GLOBALS['MessageEntryFmt'],\$pagename))"); 
  SDV($InlineReplacements['/\\[\\[\\$Wikilog(chrono)?\\]\\]/e'],
     "str_replace('\$Chrono','\$1',
               FmtPageName(\$GLOBALS['CalendarEntryFmt'],\$pagename))"); 
}

function HandleJDMPost($pagename) {
  global $_POST;
  if ($_POST['order'][0]=='x')
    HandleWikilogPost($pagename);
  else
    HandleMessagePost($pagename);
}

function HandlePostNoAuth($pagename) {
  global $WikiDir,$DeleteKeyWord,$RecentChanges,$RCDelimPattern,$Now,
    $TimeFmt,$CurrentTime,$PageFileFmt,$DiffKeepDays,$Author,$PostFields,
    $DiffFunction,$ChangeSummary;
  $CurrentTime = strftime($TimeFmt,$Now);
  foreach($PostFields as $k) {
    if (isset($_POST[$k]))
      $new[$k]=str_replace("\r","",stripmagic($_POST[$k])); 
  }
  Lock(2);
  $pagename = FmtPageName('$PageName',$pagename);

  if ($new['text']==$page['text']) { 
    Redirect($pagename); return; 
  }

  $diffclass=preg_replace('/\\W/','',@$_POST['diffclass']);
  if ($page["time"]>0)  
    $new["diff:$Now:".$page['time'].":$diffclass"] = 
      $DiffFunction($new['text'],$page['text']); 
  $new['author'] = $Author;
  $new["author:$Now"] = $Author;
  $new["host:$Now"] = $_SERVER['REMOTE_ADDR'];
  if ($ChangeSummary) $new["csum:$Now"] = $ChangeSummary;
  foreach($new as $k=>$v) {
    if ($k=='pagename' || $k=='action') continue;
    $page[$k] = $v;
  }
  $keepgmt = $Now-$DiffKeepDays*86400;
  $keys = array_keys($page);
  foreach ($keys as $k) 
    if (preg_match("/^\\w+:(\\d+)/",$k,$match))
      if ($match[1] < $keepgmt) unset($page[$k]);
  $pagefile = FmtPageName($PageFileFmt,$pagename);
  if ($page['text']==$DeleteKeyWord) 
    { @rename("$WikiDir/$pagefile","$WikiDir/$pagefile,$Now"); }
  else WritePage($pagename,$page);
  foreach($RecentChanges as $rcfmt => $pgfmt) {
    $rcname=FmtPageName($rcfmt,$pagename); if (!$rcname) continue;
    $pgtext=FmtPageName($pgfmt,$pagename); if (!$pgtext) continue;
    if (@$seen[$rcname]++) continue;
    $rcpage = ReadPage($rcname,"");
    $rcelim = preg_quote(preg_replace("/$RCDelimPattern.*$/",' ',$pgtext),'/');
    $rcpage['text'] = preg_replace("/[^\n]*$rcelim.*\n/","",$rcpage['text']);
    if (!preg_match("/$RCDelimPattern/",$rcpage['text'])) 
      $rcpage['text'] .= "$pgtext\n";
    else 
      $rcpage['text'] = preg_replace("/([^\n]*$RCDelimPattern.*\n)/",
        "$pgtext\n$1",$rcpage['text'],1);
    WritePage($rcname,$rcpage);
  }
  Redirect($pagename); 
}

function Untaint($text) {
  // Filter out WikiWords
  $text = preg_replace("/([[:upper:]][[:alnum:]]*(?:[[:upper:]][[:lower:]0-9]|[[:lower:]0-9][[:upper:]])[[:alnum:]]*)/", "[=\\1=]", $text);

  // Filter out {{, }}, [[, and ]]
  $text = preg_replace("/(\[\[|{{|\]\]|}})/", "[=\\1=]", $text);
  return $text;
}

function HandleMessagePost($pagename) {
  global $_POST, $JournalDateFmt, $JournalTimeFmt;
  $name = Untaint($_POST['author']);
  $url = Untaint($_POST['url']);
  #$name = ($name=='') ? 'anonymous' : '{{~' . $name . '}}';
  $name = ($name=='') ? 'anonymous' : $name;
  $now  = time();
  $date = "'''".strftime($JournalDateFmt,$now)."'''";
  $time = "%blogcomment%[=".strftime($JournalTimeFmt,$now). "=] by '''$name''' ";
  
  if($url) {
    $time .= "($url)%%\n\n";
  }
  else {
    $time .= "%%\n\n";
  }

  $_POST['text'] = Untaint($_POST['text']);

  $page = ReadPage($pagename);
  
  $order = $_POST['order'];
  $preview = $_POST['preview'];

  if($preview) {
    HandleMessagePreview($pagename,$name,$url);
    return;
  }
  
  if ($order=='') {
    if (strstr($page['text'],'[[$Comment]]')) {
      $pos = strpos($page['text'],'[[$Comment]]');
      $len = strlen('[[$Comment]]');
      $before = substr($page['text'],0,$pos+$len);
      $after  = substr($page['text'],$pos+$len);
    } 
    else {
      $before = '';
      $after  = $page['text'];
    }
    $repl  = "$date\n\n$time" . $_POST['text'];
    if (strstr($after, $date)) {
      $after = str_replace($date, $repl, $after);
    } 
    else { 
      $after = "\n[[<<]]\n$repl\n$after";
    }
    $_POST['text'] = "$before$after";
  } 
  else {
    if (strstr($page['text'],'[[$Commentchrono]]')) {
      $pos = strpos($page['text'],'[[$Commentchrono]]');
      $before = substr($page['text'],0,$pos);
      $after  = substr($page['text'],$pos);
    } 
    else {
      $before = $page['text'];
      if ($before[strlen($before)-1]!='\n') $before .="\n\n";
      $after  = '';
    }
    if (strstr($before, $date)) {
      $repl  = "$time";
    } 
    else { 
      $repl  = "$date\n\n$time";
    }
    $repl .= $_POST['text'];
    $_POST['text'] = "$before\n[[<<]]\n$repl\n\n$after";
  }
  HandlePostNoAuth($pagename);
  exit;
}

function IndentParagraphs($text) {
  global $AnyLetter;
  $text = preg_replace("/\n($AnyLetter)/","\n->$1",$text);
  $text = preg_replace("/\n([#*])([^#*])/","\n$1$1$2",$text);
  return preg_replace("/\n:([^:]+):/","\n::$1:",$text);
}

function HandleWikilogPost($pagename) {
  global $_POST,$JournalTimeFmt;
  $name = $_POST['author'];
  $name = ($name=='') ? 'anonymous' : '{{~' . $name . '}}';
  $now = time();
  $_POST['text']= "!!".$_POST['headline']."\n".
    $_POST['text']."\n\n=>[-Posted at ".
    strftime($JournalTimeFmt,$now)." by $name-]";
  $todayspage = FmtPageName('$Group',$pagename)."/".strftime("%Y%m%d",$now);
  if (PageExists($todayspage)) {
    $page = RetrieveAuthPage($todayspage, "edit");
    $page['text'] = preg_replace("/!!!.*/", "", $page['text']);
    $_POST['text'] = "!!!" . longdate(strftime("%Y%m%d",$now)) . "\n" . 
      $_POST['text'] . "\n\n" . $page['text'];
  }
  else if ($_POST['comment'] == "comment") {
    $_POST['text'] .= "\n\n%blogcomment% '''Comments''' %%" . "\n" . '[[\$Commentchrono]]';
    $_POST['text'] = "!!!" . longdate(strftime("%Y%m%d",$now)) . "\n" . $_POST['text'];
  }
  else {
    $_POST['text'] = "!!!" . longdate(strftime("%Y%m%d",$now)) . "\n" . $_POST['text'];
  }
  
  HandlePost($todayspage);
  exit;
}

function HandleMessagePreview($pagename,$author,$url) {
  global $restore,$preview,$HandleActions,$Text,
    $HandleEditFmt,$PageStartFmt,$MessageEntryFmt,$PreviewFmt,$PageEndFmt;
    
  if (@$_POST['post']) { 
    $handle = $HandleActions['post']; 
    return $handle($pagename); 
  }
  
  $page = ReadPage($pagename);
  
  if (!$page) { 
    Abort("?cannot preview $pagename"); 
  }
  
  SetPageVars($pagename,$page,"Preview comment");
  
  $text = stripmagic($_POST['text']); 
  $Text = $text;

  $MessageEntryPreviewFmt = preg_replace("/(name='author')/", "\\1 value='$author'", $MessageEntryFmt);
  $MessageEntryPreviewFmt = preg_replace("/(name='url')/", "\\1 value='$url'", $MessageEntryPreviewFmt);
  $MessageEntryPreviewFmt = preg_replace("|(</textarea>)|", "$text\\1", $MessageEntryPreviewFmt);

 
  SDV($HandleEditFmt,array(&$PageStartFmt,
    $MessageEntryPreviewFmt,&$PreviewFmt,
    &$PageEndFmt));

  PrintFmt($pagename,$HandleEditFmt);
}

?>
